{% macro include_probing() %}{% include "nginx-service-probing.j2" %}{% endmacro %}
{% macro include_mapping(mapping) %}{% include "nginx-service-mapping.j2" %}{% endmacro %}

###############################################################################
### SERVER: SERVICE {{ service["scheme"] }}://{{ service["host"] }}:{{ service["port"] }}
###############################################################################

{%- if service["is_tls"] %}
server {
  server_name {{ service["host"] }};
  listen 80;

{%- if acme_enabled %}
  location ^~ /.well-known/acme-challenge/ {
    default_type "text/plain";
    root /var/www/acme-challenge/{{ service["host"] }};
  }
{%- endif %}

  location / {
    return 301 https://$host$request_uri;
  }
}
{%- endif %}

server {
  server_name {{ service["host"] }};

  {%- if service["is_tls"] %}
  listen {{ service["port"] }} ssl;
  http2 on;

    {%- if acme_enabled %}
  ssl_certificate     /etc/nginx/certs/acme/{{ service["host"] }}.pub;
  ssl_certificate_key /etc/nginx/certs/acme/{{ service["host"] }}.key;
    {%- else %}
  ssl_certificate     /etc/nginx/certs/{{ cert_name }}.pem;
  ssl_certificate_key /etc/nginx/certs/{{ cert_name }}.key;
    {%- endif %}

  ssl_session_timeout       15m;
  ssl_session_cache         shared:SSL:15m;
  ssl_protocols             TLSv1.2 TLSv1.3;
  ssl_ciphers               "ECDHE-RSA-AES128-GCM-SHA256:ECDHE-RSA-CHACHA20-POLY1305:ECDHE-RSA-AES256-GCM-SHA384";
  ssl_prefer_server_ciphers on;
  {%- else %}
  listen {{ service["port"] }};
  {%- endif %}

  proxy_cache_bypass $http_pragma $http_cache_control;
  proxy_cache {{ cache_zone }};
  proxy_cache_revalidate on;

  proxy_http_version 1.1;
  gzip on;

  set $default_sorry "https://sorry.ec.europa.eu";

  {{ include_probing() | indent(2) }}

{% for mapping in service["mappings"] %}
  {{ include_mapping(mapping) | indent(2) }}
{% endfor %}
}
